scala.collection.immutable

# HashSet

#### object HashSet extends ImmutableSetFactory[HashSet] with Serializable

This object provides a set of operations needed to create ``immutable.HashSet`` values.

Source
  HashSet.scala

Linear Supertypes
Serializable, java.io.Serializable, ImmutableSetFactory[HashSet], SetFactory[HashSet], GenericSeqCompanion[HashSet], GenSetFactory[HashSet], GenericCompanion[HashSet], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. HashSet
2. Serializable
3. Serializable
4. ImmutableSetFactory
5. SetFactory
6. GenericSeqCompanion
7. GenSetFactory
8. GenericCompanion
9. AnyRef
10. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### type Coll = HashSet[_]

   The underlying collection type with unknown element type

   The underlying collection type with unknown element type

   Attributes
     protected[this]
   Definition Classes
     GenericCompanion

2. #### class HashSet1[A] extends LeafHashSet[A]

3. #### class HashTrieSet[A] extends HashSet[A]

   A branch node of the HashTrieSet with at least one and up to 32 children.

   A branch node of the HashTrieSet with at least one and up to 32 children.

   A

     the type of the elements contained in this hash set.

     How levels work:

     When looking up or adding elements, the part of the hashcode that is used to address the children array depends on how deep we are in the tree. This is accomplished by having a level parameter in all internal methods that starts at 0 and increases by 5 (32 = 2^5) every time we go deeper into the tree.

     hashcode (binary): 00000000000000000000000000000000 level=0 (depth=0) level=5 (depth=1) level=10 (depth=2) ^^^^^ ...

     Be careful: a non-toplevel HashTrieSet is not a self-contained set, so e.g. calling contains on it will not work! It relies on its depth in the Trie for which part of a hash to use to address the children, but this information (the level) is not stored due to storage efficiency reasons but has to be passed explicitly!

     How bitmap and elems correspond:

     A naive implementation of a HashTrieSet would always have an array of size 32 for children and leave the unused children empty (null). But that would be very wasteful regarding memory. Instead, only non-empty children are stored in elems, and the bitmap is used to encode which elem corresponds to which child bucket. The lowest 1 bit corresponds to the first element, the second-lowest to the second, etc.

     bitmap (binary): 00010000000000000000100000000000 elems: [a,b] children: ---b----------------a-----------

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### def apply[A](elems: A*): HashSet[A]

   Creates a collection with the specified elements.

   Creates a collection with the specified elements.

   A

     the type of the collection's elements

   elems

     the elements of the created collection

   returns

     a new collection with elements `elems`

   Definition Classes
     GenericCompanion

5. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

6. #### implicit def canBuildFrom[A]: CanBuildFrom[Coll, A, HashSet[A]]

   The standard `CanBuildFrom` instance for ``immutable.HashSet`` objects.

7. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

8. #### def empty[A]: HashSet[A]

   An empty collection of type ``Set`[A]`

   An empty collection of type ``Set`[A]`

   A

     the type of the set's elements

   Definition Classes
     ImmutableSetFactory → GenericCompanion

9. #### final def eq(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

10. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

11. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

12. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

13. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

14. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

15. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

16. #### def newBuilder[A]: Builder[A, HashSet[A]]

    The default builder for ``Set`` objects.

    The default builder for ``Set`` objects.

    A

      the type of the set's elements

    Definition Classes
      ImmutableSetFactory → GenSetFactory → GenericCompanion

17. #### final def notify(): Unit

    Definition Classes
      AnyRef

18. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

19. #### def setCanBuildFrom[A]: CanBuildFrom[HashSet[_], A, HashSet[A]]

    The standard `CanBuildFrom` instance for ``Set`` objects.

    The standard `CanBuildFrom` instance for ``Set`` objects.

    Definition Classes
      GenSetFactory

20. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

21. #### def toString(): String

    Definition Classes
      AnyRef → Any

22. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

23. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

24. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from ImmutableSetFactory[HashSet]

### Inherited from SetFactory[HashSet]

### Inherited from GenericSeqCompanion[HashSet]

### Inherited from GenSetFactory[HashSet]

### Inherited from GenericCompanion[HashSet]

### Inherited from AnyRef

### Inherited from Any

### Ungrouped